// ProcessAllPictureNameLines.jsx
// InDesign CS3, CS4, CS5
// © Mikhail Ivanyushin, 2010  ivanyushin#yandex.ru
//
// InDesign CS3, CS4, CS5
//
// Program is suited to search paragraphs with image description and change each found line to real image.
// Image description — one paragraph which consists of marker of picture, <IMG> for example,  an a name of file.
// <IMG> NameOfFile
// Image isn't placed in anchored frame but in a frame on the page there the paragraph with marker of picture and name of image file is encountered.
// *** How it works ***
// Before the group line processing is started, user must keep all information about size of picture and text info about image in linkXmp area of picture description.
// Photoshop is used for do this task — File > Info : Description
//
// At start of work the program shows dialog to select a full name of directory where all images are saved.
// Next menu is for select name of marker of picture an object styles for picture frame and text ferame.
// Imagine, user select <IMG> as marker of picture.
// Script searches the lines started with <IMG>.
// Then a file with image is found, it is expected a linkXmp data of this file keep information about size of picture and text information about it if user need to place it under a picture.
// On the page there this line was put, a picture frame is made.
// The program changes the size of this frame in accordance with data in linkXmp.description.
// If in field 'Document Title' there are some words, a text frame to information about the image is placed under the picture frame.
// This information is kept in linkXmp.documentTitle.
// By default a distance between picture and texts frames is equal to 3 millimeters.
// Selected by user object style for picture frame and object style for text frame are applied to respective  frames, 
// Then both frames are grouped and placed top of the page there was text line with r of picture and name of this file.
// If numbering of pictures is needed, user must insert start number in field 'Numbering begins at'. Now a text information about each image is prefixes by word 'Fig.' and current number.
// Script places special symbol 'End Nested Style Character' after number to give user an ability 
// to use an option 'Nested Styles' in paragraph style, if visual selection of word 'Fig.' and number is required.
//
// Structure of file  All_Pictures_Processing.ini:
// First and second lines — selected by user in previous run of program indexes for object style to picture frame and object style to text frame in script's object styles menu 
// Third line — full name of directory with image files.
// Fourth line — index in marker of picture array.
// Fiveth line — gap between these frames, measured in millimeters. By default this value is equal 3 mm.
// Sixth line — a word placed before a number, by default it is 'Fig.'
//      *******

//
var myProgramTitul = "Convert Lines with Names of Image Files to Pictures  (v.3.1.1)"  //  01/07/2010
//
myDefaultDir = "C:\\tmp\\picts\\";
myStartMarkerIndex = 0; // это индекс идентификатора (по умолчанию указывает на "<IMG>")
myPictTxtGap = 3;
myGraphPrefix = "Fig.";
var myMarkerIndex;
var myImageIdentificator; //  выбранный идентификатор иллюстрации. 
var myGapBetweenPictureAndInformFrame; // вертикальная отбивка между фреймами, мм (имеются ввиду фреймы иллюстрационный и текстовый, в который помещается подпись). По умолчанию, 3 мм
var myPictureNumberPrefix; // слово, обозначающее рисунок. По умолчанию "Fig."
//
var myPictFileName;
var myTextFrame;
var myTextFrameWidth;
var myTextFrameHeight;
var myTextColumnWidth;
var myLine;
var myName;
var myInfo;
var myMissedMessage=0;
var myMissedSizes=0;
var myMessage = "";
var myLineWithTagAndPictName = new Array;
var myInfoAboutFrameSize = new Array;
var myProblemPages = new Array;
var myInsPt;
var myTmp;
var myGap;
var myPaper;
var myTopLeftY;
var myTopLeftX;
var myInLinePict;
var  myPicture;
var myLink;
var myPictureHasMessage;
var myPictureWidth;
var myPictureHeight;
var myInfoFrameHeight;
var myCurrentVertUnits;
var myNameOfCurrVertUnits;
var myFound; 
var myNameOfPicture;
var mySizeDescription;
var myFrameForPictureName;
var myFrameHeight, myFrameWidth; // высота и ширина фрейма очередного рисунка
var myObjectStyleNames = new Array;
var myGroupArray = new Array;
var myObjectIndex;
var myTxtStyleIndex;
var myPictFrameObjectStyleName;
var myTxtFrameObjectStyleName;
var myTxtObjStyle; 
var myObjectStyle;
var myNumerationIsActive;
var myTextPointSize;
var myTextVerticalScale;	
var myTextAutoLeading; 
var myLineLeading; 
var myX1;
var myX2;
var myY1;
var myY2;
var myNymberOfLines;
var myNextStep = 1;
var myPage;
var myStartNumber;
var myPageWidth;
var myPageHeight;
var myPictIndex;
var myTextIndex;
var myLineWithNameOfIniFile;
var mySetProcFile;

myLine001 = "Identificator of Image:  " 
myLine007 = "Object Style for Text:   "
myLine008 = "Object Style for Picture:"
myLine012 = "© Mikhail Ivanyushin, 2010"
myLine011 = "Numbering begins at    "
myLine009 =  "adobeindesign.ru         "
myUnitIsCustomPoints = 1131639917
myAuto = 1635019116; // нумератор для интерлиньяжа Auto
myEndNestedStyle = "\u0003";
var myMarkerNamesArray = new Array;
myMarkerNamesArray[0] = "<IMG>";
myMarkerNamesArray[1] = "<IMAGE>";
myMarkerNamesArray[2] = "<PICT>";
mySpace = " ";
///////
app.scriptPreferences.version = 6;
if (app.documents.length != 0)  { // app.doc     
var mySelection = app.selection[0];
var myDocument = app.documents.item(0);
myCurrentVertUnits = myDocument.viewPreferences.verticalMeasurementUnits;
if (myCurrentVertUnits == myUnitIsCustomPoints) { alert("Custom units are not supported",myProgramTitul); exit(0); }
while (myProblemPages.length != 0) { a = myProblemPages.pop(); } // очистим массив myProblemPages[], если в нём есть какие-то записи
if(app.selection.length != 0) { // !=0
	a=0;
switch(mySelection.constructor.name) { // switch
	case "InsertionPoint":
	var myStory = mySelection.parentStory;	
	myTextFrame = myStory.textContainers[0];
	myTextColumnWidth = myTextFrame.textFramePreferences.textColumnFixedWidth; // это ширина колонки текста
	myTextFrameWidth = myTextFrame.geometricBounds[3] - myTextFrame.geometricBounds[1];
	myTextFrameHeight = myTextFrame.geometricBounds[2] - myTextFrame.geometricBounds[0];
	try { myPage = mySelection.parentTextFrames[0].parent.marginPreferences.parent; }
	catch (e) {
		alert("Text frame is abroad page.");
		exit(); 
	}	
	myPageWidth = myPage.bounds [3] - myPage.bounds [1];
	myPageHeight = myPage.bounds [2] - myPage.bounds [0];
	if (myStory.overflows == true)  { myInfoAndExit("Overflow."); } 
	myLineWithNameOfIniFile = myFile("All_Pictures_Processing.ini");
	mySetProcFile = new File (myLineWithNameOfIniFile);
	if (mySetProcFile.exists) { //file exists
	var myProcPath = myLineWithNameOfIniFile;
	mySetProcFile.open("r");
	try { myPictIndex = mySetProcFile.readln() } catch (e) { myPictIndex = 0; }
	try { myTextIndex = mySetProcFile.readln() } catch (e) { myTextIndex = 0; }
	try { myPath = mySetProcFile.readln() } catch (e) { myPath = myDefaultDir; }
	try { myMarkerIndex = mySetProcFile.readln() } catch (e) { myMarkerIndex = myStartMarkerIndex; }
	try { myGapBetweenPictureAndInformFrame = mySetProcFile.readln() } catch (e) { myGapBetweenPictureAndInformFrame = myPictTxtGap; }
	try { myPictureNumberPrefix = mySetProcFile.readln() } catch (e) { myPictureNumberPrefix = myGraphPrefix; }	
	mySetProcFile.close();
	} //file exists
else {
		myPictIndex = 0;
		myTextIndex = 0;
		myPath = myDefaultDir;
		myMarkerIndex = myStartMarkerIndex;
		myImageIdentificator = myMarkerNamesArray[myMarkerIndex];
		myGapBetweenPictureAndInformFrame = myPictTxtGap;
		myPictureNumberPrefix = myGraphPrefix;
}
for (i = 0; i < myDocument.objectStyles.length; i++) { myObjectStyleNames.push(myDocument.objectStyles.item(i).name);} // перечень всех созданных пользовтелем объектных стилей
if (Number(myPictIndex) >= myDocument.objectStyles.length || Number(myTextIndex) >= myDocument.objectStyles.length) { myPictIndex = 0; myTextIndex = 0; } // 
var myFolder = Folder.selectDialog ("Select Folder with Image Files", myPath); 
if(myFolder == null) { exit(); }
myPath = myFolder + "/";
var myDialog = app.dialogs.add({name:" " + myProgramTitul, canCancel:true});
with (myDialog) { // myDialog
with (dialogColumns.add()) { //.add()
	staticTexts.add({staticLabel:myLine001});
	staticTexts.add({staticLabel:myLine008});
	staticTexts.add({staticLabel:myLine007});
	staticTexts.add({staticLabel:myLine011});
//	staticTexts.add({staticLabel:" "});
	staticTexts.add({staticLabel:myLine009});
	with (dialogColumns.add()) { // lists
		var mySelectedMarker = dropdowns.add({stringList:myMarkerNamesArray, selectedIndex:Number(myMarkerIndex)});
		myObjectStyle = dropdowns.add({stringList:myObjectStyleNames, selectedIndex:Number(myPictIndex)});
		myTxtObjStyle = dropdowns.add({stringList:myObjectStyleNames, selectedIndex:Number(myTextIndex)}); 
		var myStNmbr = realEditboxes.add({});
		//staticTexts.add({staticLabel:" "});
		staticTexts.add({staticLabel:myLine012}); 
		} // lists
	} //.add()
} //myDialog
if(myDialog.show() == false) { //cancel
	myDialog.destroy();
	exit(); 
} //cancel
else { // true
	myMarkerIndex = mySelectedMarker.selectedIndex;  // индекс выбранного идентифткатора иллюстрации
	myImageIdentificator = myMarkerNamesArray[myMarkerIndex]; // название выбранного идентификатора иллюстрации
	myPictIndex = myObjectStyle.selectedIndex;  // индекс выбранного объектного стиля рисунка
	myTextIndex = myTxtObjStyle.selectedIndex;  // индекс выбранного стиля фрейма с подписью
	myPictFrameObjectStyleName = myDocument.objectStyles.item(myPictIndex);
	myTxtFrameObjectStyleName = myDocument.objectStyles.item(myTextIndex);
	//myNumerationIsActive = myNeedNumbers.checkedState;

if ( myStNmbr.editValue <0 || (myStNmbr.editValue - myStNmbr.editValue.toFixed(0)) !=0) { alert("Number must be positive and whole"); exit(); }
	myStartNumber = myStNmbr.editValue;
	myNumerationIsActive = false;
	if (myStartNumber > 0) myNumerationIsActive = true;
	myDialog.destroy();
} //true
mySetProcFile = new File (myLineWithNameOfIniFile);
mySetProcFile.open("w");
mySetProcFile.writeln(myPictIndex);
mySetProcFile.writeln(myTextIndex);
mySetProcFile.writeln(myPath);
mySetProcFile.writeln(myMarkerIndex);
mySetProcFile.writeln(myGapBetweenPictureAndInformFrame);
mySetProcFile.writeln(myPictureNumberPrefix);
mySetProcFile.close();
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myImageIdentificator; 
myFound = myStory.findText(); //собрана коллекция искомых элементов в статье
myProgressPanel = myCreateProgressPanel(myFound.length, myProgramTitul); // параметром прогресс-бара будет число найденных маркеров иллюстрации
for (i=0; i< myFound.length; i++) { // i< myFound.length
	if (myStory.overflows == true)  { myInfoAndExit("Overflow again!"); } 
	if (myPictureInMaket() != true)  { myInfoAndExit("Number of picture markers " + myImageIdentificator + " in text is more than paragraphs started with this word.\nBut all paragraphs with this makker are processed.");  }
} // i< myFound.length
if (myFound.length == 0) { myInfoAndExit("There is no paragraphs started with picture marker " + myImageIdentificator + "."); }
if (myProblemPages.length != 0) { // != 0
	myTmp = myProblemPages.join(", "); 
	if (myMissedSizes != 0) myMessage += "Images with undefined sizes are encountered.\nIts placed in squares with side equal third of width of text frame.\n";
	// пока не сделан анализ на повтор одинаковых номеров страниц
	myInfoAndExit(myMessage + "Pay attention to pages " + myTmp + ".");
} // != 0
else { myInfoAndExit("All lines with picture descriptions are processed."); }
} //switch
} // !=0
myInfoAndExit("Place cursor in text.");
} // app.doc 
alert("There is no opened documents.",myProgramTitul);
exit();
/////////
function myPictureInMaket() { //myPictureInMaket 
myInfo = myStory.texts[0].contents.search (myImageIdentificator); // индекс первого символа в предложении <PICT>... 
if (myInfo == null) return (false);
myLine = myStory.characters[myInfo].paragraphs[0].contents;
myInsPt = myInfo +myLine.length-1;
a=0;
myStory.insertionPoints[myInsPt].contents = '>'; // добавим угловую скобку, чтобы выделить маршрут к иллюстрации. Если этого не сделать, в маршрут попадет знак перевода стоки, и иллюстрация не будет найдена.
myLine = myStory.characters[myInfo].paragraphs[0].contents;
myStory.characters.itemByRange(myInsPt,myInsPt).remove(); // удалим введенную ранее угловую скобку
myLineWithTagAndPictName = myLine.split(">");
myPictFileName = File (myPath + myLineWithTagAndPictName[1]);
myPaper = myPictFileName.open("r");  
if (myPaper == false) { myInfoAndExit ("File " + decodeURI(myPictFileName)  +" not found.\nBe sure that picture markers " + myImageIdentificator + " in text and in script are absolutely the same."); }	
try { myPage = myStory.characters[myInfo].parentTextFrames[0].parent;}
catch (e) {
	alert("Text frame is abroad page.");
	exit(); 
}
myInLinePict = myPage.rectangles.add();
myTopLeftY = myStory.insertionPoints[myInfo].parentTextFrames[0].geometricBounds[0];
myTopLeftX = myStory.characters[myInfo].paragraphs[0].horizontalOffset; // координата курсора в начале строки перед маркером иллюстрации
with (myInLinePict) { // with-1
	geometricBounds = [myTopLeftY,myTopLeftX,myTopLeftY + myTextColumnWidth/2,myTopLeftX + myTextColumnWidth/2];
	} // with-1
myStory.insertionPoints[myInfo].paragraphs[0].characters.itemByRange(0,-1).remove(); // удалим строку с информацией о маршруте к иллюстрации
myInLinePict.place(myPictFileName); // помещаем в прямоугольник картинку
myPicture = myInLinePict.allGraphics[0]; // ссылка на вставленную в прямоугольник иллюстрацию
myLink =myInLinePict.allGraphics[0].itemLink;
myPictureHasMessage = true;
try { myNameOfPicture = myLink.linkXmp.documentTitle; }
catch (e) { 
	// вообще-то в эту ветку можно попасть только при отладке программы. Но пусть будет. На всякий пожарный....   :))
	myTmp = myInLinePict.parent.name;
	myTmp++;
	myInfoAndExit ("Attempt to read information for image on page " + myTmp + " is unsuccesful.");
}
var myPictPrefix ="";
if (myNumerationIsActive == true) { // myNumerationIsActive == true
	myPictPrefix = myPictureNumberPrefix + mySpace + myStartNumber + "." + mySpace + myEndNestedStyle;
	myStartNumber++;
}	// myNumerationIsActive == true
myNameOfPicture = myPictPrefix + myNameOfPicture;
if (myNameOfPicture.length == 0) { // это случай, когда из поля documentTitle считана строка нулевой длины и не выбрана нумерация рисунков. Значит, не надо делать фрейм для текста под рисунком
	myPictureHasMessage = false;
}	
try { mySizeDescription = myLink.linkXmp.description; } 
catch (e) {
	// вообще-то в эту ветку можно попасть только при отладке программы. Но пусть будет. На всякий пожарный....   :))
	myTmp = myInLinePict.parent.name;
	myTmp++;
	//myInfoAndExit ("Не удалось считать информацию о размерах иллюстрации иллюстрации, описание которой размещено на " + myTmp + " странице.");
	myInfoAndExit ("Attempt to read information about sizes of image on page " + myTmp + " is unsuccesful.");
}
mySizeDescription = mySizeDescription.replace(",", "\."); // если при задании размеров использовались запятые для отделения целой части от дробной, они будут заменены на точки
myInfoAboutFrameSize = mySizeDescription.split("/"); // список разбит на отдельные записи в массиве
if (myInfoAboutFrameSize.length != 2)  {
	myMissedSizes++;
	myFrameHeight = myTextColumnWidth/3;
	myFrameWidth = myTextColumnWidth/3;
	myTmp = myInLinePict.parent.name;
	myTmp++;
	myProblemPages.push(myTmp);
}
else {
	myFrameHeight = Number(myInfoAboutFrameSize[1]);
	myFrameWidth = Number(myInfoAboutFrameSize[0]);
}
if (((myFrameHeight <=0) || (myFrameHeight > myPageHeight)) || ((myFrameWidth <= 0) || (myFrameWidth >= myPageWidth))) {
// заданные габариты или отрицательные, или хотя бы по одному размеру иллюстрация превышает габариты страницы
	myMissedSizes++;
	myFrameHeight = myTextColumnWidth/3;
	myFrameWidth = myTextColumnWidth/3;
	myTmp = myInLinePict.parent.name;
	myTmp++;
	myProblemPages.push(myTmp);
}
myPictureWidth= myPicture.geometricBounds[3] - myPicture.geometricBounds[1];
myPictureHeight = myPicture.geometricBounds[2] - myPicture.geometricBounds[0];
with (myInLinePict) { // with
		geometricBounds = [myTopLeftY,myTopLeftX,myTopLeftY+myFrameHeight,myTopLeftX+myFrameWidth];
		strokeWeight = 0;
	} // with
myInLinePict.applyObjectStyle (myDocument.objectStyles.item(0)); // [None]
myInLinePict.applyObjectStyle (myPictFrameObjectStyleName);
if (myPictureHasMessage == true) { //  myPictureHasMessage == true 
	// для текущей иллюстрации есть описание
	myFrameForPictureName = myPage.textFrames.add(); // в этом текстовом фрейме на текущей странице будет название иллюстрации
	with (myInLinePict) { // координаты картинки после масштабирования
		myX1= geometricBounds[1];
		myX2= geometricBounds[3];
		myY1= geometricBounds[0];
		myY2= geometricBounds[2];
	}  // координаты картинки после масштабирования
	with (myFrameForPictureName) { //with
		geometricBounds = [myTopLeftY , myTopLeftX, myTopLeftY + myTextColumnWidth/3, myX2];	// myTextColumnWidth/3 -- высота фрейма с ба-а-льшим запасом
		strokeWeight = 0;
		textFramePreferences.ignoreWrap = true; // вообще-то эта установка должна быть в описании стиля текстового фрейма для подписи под иллюстрацией
		contents = myNameOfPicture;
		parentStory.appliedParagraphStyle =myDocument.paragraphStyles.item(0); // [None]
		parentStory.appliedCharacterStyle =myDocument.characterStyles.item(0); // [None]
		applyObjectStyle (myDocument.objectStyles.item(0)); // [None]
		applyObjectStyle (myTxtFrameObjectStyleName);		
		myTextPointSize = parentStory.pointSize;
		myTextVerticalScale = parentStory.verticalScale;	
		myTextAutoLeading = parentStory.autoLeading; 
		myLineLeading = parentStory.leading; 
		if (myLineLeading == myAuto) { myLineLeading = (myTextPointSize * myTextAutoLeading /100) * myTextVerticalScale/100; }	
		myNymberOfLines = parentStory.lines.length;
		a=0;
// Создаем ассоциативный массив с возможными единицами измерения. В программе описание этой функции должно быть раньше, чем обращение к ней.
var myUnits = (function() {
var mySpecialArrayOfUnits = {}, MyInDesignUnits = MeasurementUnits;
mySpecialArrayOfUnits[MyInDesignUnits.MILLIMETERS] = "mm";
mySpecialArrayOfUnits[MyInDesignUnits.CENTIMETERS] = "cm";
mySpecialArrayOfUnits[MyInDesignUnits.POINTS] = "pt";
mySpecialArrayOfUnits[MyInDesignUnits.INCHES] = "in";
mySpecialArrayOfUnits[MyInDesignUnits.INCHES_DECIMAL] = "in";
mySpecialArrayOfUnits[MyInDesignUnits.PICAS] = "pc";
mySpecialArrayOfUnits[MyInDesignUnits.CICEROS] = "ci";
mySpecialArrayOfUnits[MyInDesignUnits.AGATES] = "agt";
// в версии CS5, видимо, будут еще и пиксели как единица задания размеров в программе
return (mySpecialArrayOfUnits);
})();	
////////
		myTmp = UnitValue (myGapBetweenPictureAndInformFrame, "mm"); // вертикальная отбивка между фреймами, мм (имеются ввиду иллюстрационный и текстовый, в который помещается подпись)
		myGap = myTmp.as(myUnits[myCurrentVertUnits]); // эта отбивка в текущих единицах измерения   
		myTmp = UnitValue (myLineLeading*myNymberOfLines, "pt"); // высота фрейма для подписи в пунктах
		myInfoFrameHeight = myTmp.as(myUnits[myCurrentVertUnits]); // высота фрейма в текущих единицах измерения
		geometricBounds = [myY2+myGap, myX1, myY2+myInfoFrameHeight+myGap, myX2]; 
		textFramePreferences.ignoreWrap = true;
	} //with
// перед тем, как сгруппировать объекты, их надо собрать в одном массиве
	myGroupArray.push(myFrameForPictureName);
	myGroupArray.push(myInLinePict);
	myGroup = myPage.groups.add(myGroupArray); 
	while (myGroupArray.length !=0) { myTmpObj = myGroupArray.pop(); } // после группировки масив обнуляется для создания очередной группы
} //  myPictureHasMessage == true 	
myStepByStep(myProgressPanel,myNextStep);
myNextStep++;
return (true);
} //myPictureInMaket
///
function myInfoAndExit(myInfoMessage) {
alert (myInfoMessage,myProgramTitul);
exit();
}
///
function myCreateProgressPanel(myMaximumValue,myInfoProgressLine) { 
var myProgressPanel = new Window('window', myInfoProgressLine);
	with(myProgressPanel){
		myProgressPanel.myProgressBar = add('progressbar', [12, 12, 900, 24], 0, myMaximumValue);
		myProgressPanel.show();
		myProgressbarShow = true;
		}
return myProgressPanel;
} 
///
function myStepByStep(myProgressPanel,myProgressIndex) {
myProgressPanel.myProgressBar.value = myProgressIndex; 
return;
}
///
function myFile(myFileName) { //FC
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
//if(File(myFilePath).exists == false){
		/*Display a dialog.
		myFilePath = File.openDialog("Choose the file containing your find/change list"); */
		//alert("Не найден файл " +  myFileName + " Он должен быть в том же каталоге, где размещен этот скрипт. ");
		//exit();
		//}
return myFilePath;
} //FC
//
function myGetScriptPath() { //myGetScriptPath()
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()
