// ProcessSelectedPictureNameLine.jsx
// InDesign CS3, CS4, CS5
// © Mikhail Ivanyushin, 2010  ivanyushin#yandex.ru
//
// Program is suited to change selected by user paragraph with name of image file to real image.
// Image isn't placed in anchored frame but in a frame on the page there the paragraph with name of image file is encountered.
// It's supposed what user while make up will from time to time make paragraph with name of image file, select this line and run the script.
// *** How it works ***
// Before the line processing is started, user must keep all information about size of picture and text info about image in linkXmp area of picture description.
// Photoshop is used for do this task -- File > Info : Description
// At start of work the program shows dialog to select a full name of directory where all images are saved.
// Afer run of script a file with image is found, it is expected a linkXmp data of this file keep information about size of picture and text information about it, if user need to place text under the picture.
// On the page there this line was put, a picture frame is made.
// The program changes the size of this frame in accordance with data in linkXmp.description.
// If in field 'Document Title' there are some words, a text frame to information about the image is placed under the picture frame.
// This information is kept in linkXmp.documentTitle.
// By default a distance between picture frame and texts frame is equal to 3 millimeters.
// Selected by user object style for picture frame and object style for text frame are applied to respective  frames. 
// Then both frames are grouped and placed top of the page there was text line with name of this file.
//
// If numbering of pictures is needed, user must insert at once a number in field 'Numbering begins at'. 
// Now in each next run of script in this field will be showed next number.
// In this mode a text information about each image is prefixed by word 'Fig.' and current number.
// Script places special symbol 'End Nested Style Character' after number to give user an ability 
// to use an option 'Nested Styles' in paragraph style, if visual selection of word 'Fig.' and number is required.
//
// Structure of file  One_Picture_Processing.ini:
// First and second lines — selected by user in previous run of script indexes for object style to picture frame and object style to text frame in object styles menu 
// Third line — full name of directory with image files.
// Fourth line — gap between these frames, measured in millimeters. By default this value is equal 3 mm.
// Fiveth line — a word placed before a number, by default it is 'Fig.'
// Sixth line — next number
//      *******
//
var myProgramTitul = "Convert Selected Line with Name of Image File to Picture  (v.3.2.1)"  //  01/07/2010
//
myDefaultDir = "C:\\tmp\\picts\\";
myPictTxtGap = 3;
myGraphPrefix = "Fig.";
myStartNmbrFieldValue ="";
///
var myGapBetweenPictureAndInformFrame; // вертикальная отбивка между фреймами, мм (имеются ввиду фреймы иллюстрационный и текстовый, в который помещается подпись). По умолчанию, 3 мм
var myPictureNumberPrefix; // слово, обозначающее рисунок. По умолчанию "Рис."
//
var myPictFileName;
var myTextFrame;
var myTextFrameWidth;
var myTextFrameHeight;
var myTextColumnWidth;
var myLine;
var myName;
var myInfo;
var myMissedMessage=0;
var myMissedSizes=0;
var myMessage = "";
var myLineWithTagAndPictName = new Array;
var myInfoAboutFrameSize = new Array;
var myProblemPages = new Array;
var myInsPt;
var myTmp;
var myGap;
var myPaper;
var myTopLeftY;
var myTopLeftX;
var myInLinePict;
var  myPicture;
var myLink;
var myPictureHasMessage;
var myPictureWidth;
var myPictureHeight;
var myInfoFrameHeight;
var myCurrentVertUnits;
var myNameOfCurrVertUnits;
var myFound; 
var myNameOfPicture;
var mySizeDescription;
var myFrameForPictureName;
var myFrameHeight, myFrameWidth; // высота и ширина фрейма очередного рисунка
var myObjectStyleNames = new Array;
var myGroupArray = new Array;
var myPictFrameObjectStyleName;
var myTxtFrameObjectStyleName;
var myTxtObjStyle; 
var myObjectStyle;
var myNumerationIsActive;
var myTextPointSize;
var myTextVerticalScale;	
var myTextAutoLeading; 
var myLineLeading; 
var myX1;
var myX2;
var myY1;
var myY2;
var myNymberOfLines;
var myNextStep = 1;
var myPage;
var myStartNumber;
var myPageWidth;
var myPageHeight;
var myPictIndex;
var myTextIndex;
var myLineWithNameOfIniFile;
var mySetProcFile;
var myNeedNumbers;
var myStNmbr;
myProblemInSizeDescription = false;
 
myLine007 = "Object Style for Text:   "
myLine008 = "Object Style for Picture:"
myLine012 = "© Mikhail Ivanyushin, 2010"
myLine011 = "Number of the picture: "
myLine009 =  "adobeindesign.ru          "


myUnitIsCustomPoints = 1131639917
myAuto = 1635019116; // нумератор для интерлиньяжа Auto
myEndNestedStyle = "\u0003";
mySpace = " ";
///////
app.scriptPreferences.version = 6;
if (app.documents.length != 0)  { // app.doc     
var mySelection = app.selection[0];
var myDocument = app.documents.item(0);
myCurrentVertUnits = myDocument.viewPreferences.verticalMeasurementUnits;
if (myCurrentVertUnits == myUnitIsCustomPoints) { alert("Custom units are not supported",myProgramTitul); exit(0); }
while (myProblemPages.length != 0) { a = myProblemPages.pop(); } // очистим массив myProblemPages[], если в нём есть какие-то записи
if(app.selection.length != 0) { // !=0
switch(mySelection.constructor.name) { // switch
	case "Paragraph":
	var myStory = mySelection.parentStory;	
	myTextFrame = myStory.textContainers[0];
	myTextColumnWidth = myTextFrame.textFramePreferences.textColumnFixedWidth; // это ширина колонки текста
	myTextFrameWidth = myTextFrame.geometricBounds[3] - myTextFrame.geometricBounds[1];
	myTextFrameHeight = myTextFrame.geometricBounds[2] - myTextFrame.geometricBounds[0];
	try { myPage = mySelection.parentTextFrames[0].parent.marginPreferences.parent; }
	catch (e) {
		alert("Text frame is abroad page.");
		exit(); 
	}	
	myPageWidth = myPage.bounds [3] - myPage.bounds [1];
	myPageHeight = myPage.bounds [2] - myPage.bounds [0];
	//// dialog
myLineWithNameOfIniFile = myFile("One_Picture_Processing.ini");
mySetProcFile = new File (myLineWithNameOfIniFile);
if (mySetProcFile.exists) { //file exists
	var myProcPath = myLineWithNameOfIniFile;
	mySetProcFile.open("r");
	try { myPictIndex = mySetProcFile.readln() } catch (e) { myPictIndex = 0; }
	try { myTextIndex = mySetProcFile.readln() } catch (e) { myTextIndex = 0; }
	try { myPath = mySetProcFile.readln() } catch (e) { myPath = myDefaultDir; }
//	try { myImageIdentificator = mySetProcFile.readln() } catch (e) { myImageIdentificator = myMarker; }
	try { myGapBetweenPictureAndInformFrame = mySetProcFile.readln() } catch (e) { myGapBetweenPictureAndInformFrame = myPictTxtGap; }
	try { myPictureNumberPrefix = mySetProcFile.readln() } catch (e) { myPictureNumberPrefix = myGraphPrefix; }	
	try { myStartNumber = mySetProcFile.readln() } catch (e) { myStartNumber = myStartNmbrFieldValue; }
	mySetProcFile.close();
	} //file exists
else {
		myPictIndex = 0;
		myTextIndex = 0;
		myPath = myDefaultDir;
		myGapBetweenPictureAndInformFrame = myPictTxtGap;
		myPictureNumberPrefix = myGraphPrefix;
		myStartNumber = myStartNmbrFieldValue;
}
for (i = 0; i  < myDocument.objectStyles.length; i++) { myObjectStyleNames.push(myDocument.objectStyles.item(i).name);} // перечень всех созданных пользовтелем объектных стилей
if (Number(myPictIndex) >= myDocument.objectStyles.length || Number(myTextIndex) >= myDocument.objectStyles.length) { myPictIndex = 0; myTextIndex = 0; } // 
var myFolder = Folder.selectDialog ("Select Folder with Image Files", myPath); 
if(myFolder == null) { exit(); }
myPath = myFolder + "/";
var myDialog = app.dialogs.add({name:" " + myProgramTitul, canCancel:true});
with (myDialog) { // myDialog
with (dialogColumns.add()) { //.add()
	staticTexts.add({staticLabel:myLine008});
	staticTexts.add({staticLabel:myLine007});
	staticTexts.add({staticLabel:myLine011});
	//myNeedNumbers = checkboxControls.add({staticLabel:myLine011, checkedState:false});   
//	staticTexts.add({staticLabel:" "});
	staticTexts.add({staticLabel:myLine009});
	with (dialogColumns.add()) { // lists
		myObjectStyle = dropdowns.add({stringList:myObjectStyleNames, selectedIndex:Number(myPictIndex)});
		myTxtObjStyle = dropdowns.add({stringList:myObjectStyleNames, selectedIndex:Number(myTextIndex)}); 
		if (myStartNumber == 0) myStNmbr = realEditboxes.add({});
		else myStNmbr = realEditboxes.add({editValue:Number(myStartNumber)});
		staticTexts.add({staticLabel:myLine012});
		a=0;
		} // lists
	} //.add()
} //myDialog
if(myDialog.show() == false) { //cancel
	myDialog.destroy();
	exit(); 
} //cancel
else { // true
	myPictIndex = myObjectStyle.selectedIndex;  // индекс выбранного объектного стиля рисунка
	myTextIndex = myTxtObjStyle.selectedIndex;  // индекс выбранного стиля фрейма с подписью
	myPictFrameObjectStyleName = myDocument.objectStyles.item(myPictIndex);
	myTxtFrameObjectStyleName = myDocument.objectStyles.item(myTextIndex);
	//myNumerationIsActive = myNeedNumbers.checkedState;
	if ( myStNmbr.editValue < 0 || (myStNmbr.editValue - myStNmbr.editValue.toFixed(0)) !=0) { alert("Number must be positive and whole"); exit(); }
	myStartNumber = myStNmbr.editValue;
	myNumerationIsActive = false;
	if (myStartNumber > 0) myNumerationIsActive = true;
	myDialog.destroy();
	myPictureInMaket();
	mySetProcFile = new File (myLineWithNameOfIniFile);
	mySetProcFile.open("w");
	mySetProcFile.writeln(myPictIndex);
	mySetProcFile.writeln(myTextIndex);
	mySetProcFile.writeln(myPath);
//mySetProcFile.writeln(myImageIdentificator);
	mySetProcFile.writeln(myGapBetweenPictureAndInformFrame);
	mySetProcFile.writeln(myPictureNumberPrefix);
	if (myNumerationIsActive == true) myStartNumber++;
	else myStartNumber = myStartNmbrFieldValue;
	mySetProcFile.writeln(myStartNumber);
	mySetProcFile.close();	
	exit();
} //true
} //switch
} // !=0
alert("Select paragraph with name of image file.");
exit();
} // app.doc 
alert("There is no opened documents.",myProgramTitul);
exit();
/////////
function myPictureInMaket() { //myPictureInMaket 
myInfo = mySelection; 
myLine = myStory.characters[myInfo.index].paragraphs[0].contents;
myInsPt = myInfo.index +myLine.length-1;
myStory.insertionPoints[myInsPt].contents = '>'; // добавим угловую скобку, чтобы выделить имя иллюстрации. Если этого не сделать, в маршрут попадет знак перевода стоки, и иллюстрация не будет найдена.
myLine = myStory.characters[myInfo.index].paragraphs[0].contents;
myLineWithTagAndPictName = myLine.split(">");
myPictFileName = File (myPath + myLineWithTagAndPictName[0]);
myStory.characters.itemByRange(myInsPt,myInsPt).remove(); // удалим введенную ранее угловую скобку
myPaper = myPictFileName.open("r");  
if (myPaper == false) {  // == false
	if (myStory.characters[-1].contents != '\u000D') { // != '\u000D'
		myInfoAndExit ("File " + decodeURI(myPictFileName)  +" not found.\nBe sure there is carriage return sign after name of file."); 
	} // != '\u000D'
	else myInfoAndExit ("File " + decodeURI(myPictFileName)  +" not found."); 
} // == false	
//myStory.insertionPoints[myInfo.index].paragraphs[0].characters.itemByRange(0,-1).remove(); // удалим строку с информацией о маршруте к иллюстрации
try { myPage = mySelection.parentTextFrames[0].parent.marginPreferences.parent; }
catch (e) {
	alert("Text frame is abroad page.");
	exit(); 
}
myInLinePict = myPage.rectangles.add();
myTopLeftY = myStory.insertionPoints[myInfo.index].parentTextFrames[0].geometricBounds[0];
myTopLeftX = myStory.characters[myInfo.index].paragraphs[0].horizontalOffset; // координата курсора в начале строки перед маркером иллюстрации
with (myInLinePict) { // with-1
	geometricBounds = [myTopLeftY,myTopLeftX,myTopLeftY + myTextColumnWidth/2,myTopLeftX + myTextColumnWidth/2];
	} // with-1
myStory.insertionPoints[myInfo.index].paragraphs[0].characters.itemByRange(0,-1).remove(); // удалим строку с информацией о маршруте к иллюстрации
myInLinePict.place(myPictFileName); // помещаем в прямоугольник картинку
myPicture = myInLinePict.allGraphics[0]; // ссылка на вставленную в прямоугольник иллюстрацию
myLink =myInLinePict.allGraphics[0].itemLink;
myPictureHasMessage = true;
try { myNameOfPicture = myLink.linkXmp.documentTitle; }
catch (e) { 
	// вообще-то в эту ветку можно попасть только при отладке программы. Но пусть будет. На всякий пожарный....   :))
	myTmp = myInLinePict.parent.name;
	myTmp++;
	myInfoAndExit ("Attempt to read information to image on page " + myTmp + " is unsuccesful.");
}
var myPictPrefix ="";
if (myNumerationIsActive == true) { // myNumerationIsActive == true
	myPictPrefix = myPictureNumberPrefix + mySpace + myStartNumber + "." + mySpace + myEndNestedStyle;
	//myStartNumber++;
} // myNumerationIsActive == true
myNameOfPicture = myPictPrefix + myNameOfPicture;
if (myNameOfPicture.length == 0) { // это случай, когда из поля documentTitle считана строка нулевой длины и не выбрана нумерация рисунков. Значит, не надо делать фрейм для текста под рисунком
	myPictureHasMessage = false;
}	
try { mySizeDescription = myLink.linkXmp.description; } 
catch (e) {
	// вообще-то в эту ветку можно попасть только при отладке программы. Но пусть будет. На всякий пожарный....   :))
	myTmp = myInLinePict.parent.name;
	myTmp++;
	myInfoAndExit ("Attempt to read information about sizes of image on page " + myTmp + " is unsuccesful.");
}
mySizeDescription = mySizeDescription.replace(",", "\."); // если при задании размеров использовались запятые для отделения целой части от дробной, они будут заменены на точки
myInfoAboutFrameSize = mySizeDescription.split("/"); // список разбит на отдельные записи в массиве
if (myInfoAboutFrameSize.length != 2)  {
	myFrameHeight = myTextColumnWidth/3;
	myFrameWidth = myTextColumnWidth/3;
	myProblemInSizeDescription = true;
	}
else {
	myFrameHeight = Number(myInfoAboutFrameSize[1]);
	myFrameWidth = Number(myInfoAboutFrameSize[0]);
}
if (((myFrameHeight <=0) || (myFrameHeight > myPageHeight)) || ((myFrameWidth <= 0) || (myFrameWidth >= myPageWidth)) && (myProblemInSizeDescription == false)) {
	alert ("Image with undefined sizes is encountered.\nIt placed in square with side equal third of width of text frame.",myProgramTitul);
	myFrameHeight = myTextColumnWidth/3;
	myFrameWidth = myTextColumnWidth/3;
	//return false;
}
myPictureWidth= myPicture.geometricBounds[3] - myPicture.geometricBounds[1];
myPictureHeight = myPicture.geometricBounds[2] - myPicture.geometricBounds[0];
with (myInLinePict) { // with
		geometricBounds = [myTopLeftY,myTopLeftX,myTopLeftY+myFrameHeight,myTopLeftX+myFrameWidth];
		strokeWeight = 0;
	} // with
myInLinePict.applyObjectStyle (myDocument.objectStyles.item(0)); // [None]
myInLinePict.applyObjectStyle (myPictFrameObjectStyleName);
if (myPictureHasMessage == true) { //  myPictureHasMessage == true 
	// для текущей иллюстрации есть описание
	myFrameForPictureName = myPage.textFrames.add(); // в этом текстовом фрейме на текущей странице будет название иллюстрации
	with (myInLinePict) { // координаты картинки после масштабирования
		myX1= geometricBounds[1];
		myX2= geometricBounds[3];
		myY1= geometricBounds[0];
		myY2= geometricBounds[2];
	}  // координаты картинки после масштабирования
	with (myFrameForPictureName) { //with
		geometricBounds = [myTopLeftY , myTopLeftX, myTextColumnWidth/3, myX2];	// myTextColumnWidth/3 -- высота фрейма с ба-а-льшим запасом
		strokeWeight = 0;
		textFramePreferences.ignoreWrap = true; // вообще-то эта установка должна быть в описании стиля текстового фрейма для подписи под иллюстрацией
		contents = myNameOfPicture;
		parentStory.appliedParagraphStyle =myDocument.paragraphStyles.item(0); // [None]
		parentStory.appliedCharacterStyle =myDocument.characterStyles.item(0); // [None]
		applyObjectStyle (myDocument.objectStyles.item(0)); // [None]
		applyObjectStyle (myTxtFrameObjectStyleName);		
		myTextPointSize = parentStory.pointSize;
		myTextVerticalScale = parentStory.verticalScale;	
		myTextAutoLeading = parentStory.autoLeading; 
		myLineLeading = parentStory.leading; 
		if (myLineLeading == myAuto) { myLineLeading = (myTextPointSize * myTextAutoLeading /100) * myTextVerticalScale/100; }	
		myNymberOfLines = parentStory.lines.length;
// Создаем ассоциативный массив с возможными единицами измерения. В программе описание этой функции должно быть раньше, чем обращение к ней.
var myUnits = (function() {
var mySpecialArrayOfUnits = {}, MyInDesignUnits = MeasurementUnits;
mySpecialArrayOfUnits[MyInDesignUnits.MILLIMETERS] = "mm";
mySpecialArrayOfUnits[MyInDesignUnits.CENTIMETERS] = "cm";
mySpecialArrayOfUnits[MyInDesignUnits.POINTS] = "pt";
mySpecialArrayOfUnits[MyInDesignUnits.INCHES] = "in";
mySpecialArrayOfUnits[MyInDesignUnits.INCHES_DECIMAL] = "in";
mySpecialArrayOfUnits[MyInDesignUnits.PICAS] = "pc";
mySpecialArrayOfUnits[MyInDesignUnits.CICEROS] = "ci";
mySpecialArrayOfUnits[MyInDesignUnits.AGATES] = "agt";
// в версии CS5, видимо, будут еще и пиксели как единица задания размеров в программе
return (mySpecialArrayOfUnits);
})();	
////////
		myTmp = UnitValue (myGapBetweenPictureAndInformFrame, "mm"); // вертикальная отбивка между фреймами, мм (имеются ввиду иллюстрационный и текстовый, в который помещается подпись)
		myGap = myTmp.as(myUnits[myCurrentVertUnits]); // эта отбивка в текущих единицах измерения   
		myTmp = UnitValue (myLineLeading*myNymberOfLines, "pt"); // высота фрейма для подписи в пунктах
		myInfoFrameHeight = myTmp.as(myUnits[myCurrentVertUnits]); // высота фрейма в текущих единицах измерения
		geometricBounds = [myY2+myGap, myX1, myY2+myInfoFrameHeight+myGap, myX2]; 
		textFramePreferences.ignoreWrap = true;
	} //with
// перед тем, как сгруппировать объекты, их надо собрать в одном массиве
	myGroupArray.push(myFrameForPictureName);
	myGroupArray.push(myInLinePict);
	myGroup = myPage.groups.add(myGroupArray); 
	while (myGroupArray.length !=0) { myTmpObj = myGroupArray.pop(); } // после группировки масив обнуляется для создания очередной группы
} //  myPictureHasMessage == true 	
return true;
} //myPictureInMaket
///
function myInfoAndExit(myInfoMessage) {
alert (myInfoMessage,myProgramTitul);
exit();
}
///
function myFile(myFileName) { //FC
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
//if(File(myFilePath).exists == false){
		/*Display a dialog.
		myFilePath = File.openDialog("Choose the file containing your find/change list"); */
		//----alert("Не найден файл " +  myFileName + " Он должен быть в том же каталоге, где размещен этот скрипт. ");
		//exit();
//		}
return myFilePath;
} //FC
//
function myGetScriptPath() { //myGetScriptPath()
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()
